/*
**	$Id: ModemService.hpp 1.3 1995/09/26 19:45:11 olsen Exp olsen $
**
**	:ts=4
*/

/*
 * Copyright  1995 by Olaf Barthel, All Rights Reserved
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO
 * EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * This software has not been validated by the ``Bundesamt fuer Zulassungen in
 * der Telekommunikation'' of the ``Deutsche Bundepost Telekom'' and thus
 * must not be used for accessing the BTX-Network of the Telekom in Germany.
 *
 * Diese Software hat keine Zulassung durch das Bundesamt fuer Zulassungen in
 * der Telekommunikation der Deutschen Bundespost Telekom und darf daher nicht
 * am Netz der Deutschen Bundespost Telekom in Deutschland betrieben werden.
 */

#ifndef _MODEMSERVICE_HPP
#define _MODEMSERVICE_HPP 1

#include "IOChannel.hpp"
#include "BTXDisplay.hpp"

enum
{
	MODEM_Ok,
	MODEM_NoCarrier,
	MODEM_Error,
	MODEM_Busy,
	MODEM_NoDialTone,
	MODEM_Connect,
	MODEM_NoAnswer,
	MODEM_Ring,
	MODEM_Ringing,

	MODEM_Timeout
};

class ModemService
{
	public:

		ModemService();
		~ModemService();

		LONG Open(IOChannel *Channel,BTXDisplay *Display);
		VOID Close(VOID);

		LONG Connect(CONST STRPTR InitCommand,CONST STRPTR DialCommand,CONST STRPTR Number,CONST STRPTR HangupCommand);
		VOID Disconnect(VOID);

	private:

		IOChannel			*AppChannel;
		BTXDisplay			*AppDisplay;
		STRPTR				 HangupCommand;
		BOOL				 Connected;
		LONG				 Next;

		struct MsgPort		*TimePort;
		struct timerequest	*TimeRequest;
		ULONG				 TimeMask;

		LONG GetLine(STRPTR Buffer,LONG Size);
		VOID SendCommand(CONST STRPTR Command);
};

#endif	// _MODEMSERVICE_HPP
